  MEMBER
  Include('tXML.inc')

  Map
    Module('Windows')
      TXM::GetLastError(),LONG,PASCAL,NAME('GetLastError')
      TXM::FormatMessage(ULONG dwFlags,LONG lpSource,ULONG dwMessageId,ULONG LanguageId,*CSTRING lpBuffer,ULONG nSize,ULONG Args),LONG,RAW,PASCAL,NAME('FormatMessageA')
      TXM::CreateFile(*CSTRING,ULONG,ULONG,LONG,ULONG,ULONG,UNSIGNED=0),UNSIGNED,RAW,PASCAL,NAME('CreateFileA')
      TXM::GetFileSize(LONG hFile, *LONG FileSizeHigh),LONG,RAW,PASCAL,NAME('GetFileSize')
      TXM::ReadFile(LONG hFile, LONG lpBuffer, LONG dwBytes, *LONG dwBytesRead, LONG lpOverlapped),BOOL,RAW,PASCAL,NAME('ReadFile')
      TXM::WriteFile(LONG,*STRING, LONG, *LONG, LONG),LONG,RAW,PASCAL,PROC,NAME('WriteFile')
      TXM::CloseHandle(UNSIGNED),BOOL,PASCAL,RAW,PROC,NAME('CloseHandle')

      !    UTF-8
      TXM::WideCharToMultiByte(UNSIGNED Codepage=0,USHORT dwFlags=0,ULong LpWideCharStr, Long cchWideChar, ULong lpMultuByteStr, |
                               Long cbMultiByte,Ulong LpDefalutChar,BYTE lpUsedDefalutChar),Raw,UNSIGNED,Pascal,NAME('WideCharToMultiByte')

      TXM::MultiByteToWideChar(UNSIGNED Codepage=0,USHORT dwFlags=0,ULong LpMultuByteStr,Long cbMultiByte, ULong LpWideCharStr,|
                               Long cchWideChar),UNSIGNED,RAW,PASCAL,NAME('MultiByteToWideChar')

      TXM::GETACP(),RAW,USHORT,PASCAL,NAME('GETACP')

      TXM::CoCreateGuid(*?),UNSIGNED,PASCAL,Raw,Name('CoCreateGuid')
      TXM::StringFromGUID2(*?,*?,LONG cchMax),UNSIGNED,PASCAL,Raw,Name('StringFromGUID2')
      TXM::GetDiskFreeSpace(Long,Long,Long,Long,Long),Raw,Pascal,Name('GetDiskFreeSpaceA')
      TXM::MemCpy(Long,Long,Long),Name('_memcpy')
    end

    Module('tXML.clw')  !  
      TXM::XmlFileToStrUTF(*? zXMLFile_),string   !  XML     ANSI  UTF8
      TXM::StrAnsiToUTF(   *? zStr1251_),string   !  XML              ANSI  UTF8
      TXM::ANSItoUTF8(String pStr),String         !    ANSI -> UTF8
      TXM::UTF8toANSI(String pStr),String         !    UTF8 -> ANSI
      TXM::Mess(String sText,String sScene)       !  
                                                  !    
      TXM::ReplaceText(*String Stroka_,String Template_,String Field_,Long xFindTimes_ = 0)
    end
  end

INVALID_HANDLE_VALUE EQUATE(-1)

! ---  XML

ToyXML.Construct     Procedure
  Code
  Self.qDomList &= New(DOMQueue)      !  DOM  
  Self.qRules   &= New(TXM::Q_Rules)  !       
  Self.qFiles   &= New(TXM::Q_Files)  !   
  Self.qNames   &= New(TXM::Q_Names)  !     
  Self.qGroup   &= New(TXM::Q_Names)  !     

ToyXML.Destruct      Procedure
  Code
  Self.Kill  !    
  If Not (Self.qDomList &= Null) then Dispose(Self.qDomList).  !  DOM  
  If Not (Self.qRules   &= Null) then Dispose(Self.qRules).    !       
  If Not (Self.qFiles   &= Null) then Dispose(Self.qFiles).    !   
  If Not (Self.qNames   &= Null) then Dispose(Self.qNames).    !     
  If Not (Self.qGroup   &= Null) then Dispose(Self.qGroup).    !     

!   
ToyXML.Init          Procedure(byte xVid_,*? xStr_,UShort xProgress_ = 0)  !,Byte,Proc
  Code
  Self.Kill  !   

  Execute xVid_                                                 ! <--  
    Self.XmlDoc &= XMLStringToDOM(TXM::LoadStrFromFile(xStr_))  ! 1.    UTF-8
    Self.XmlDoc &= XMLStringToDOM(                     xStr_ )  ! 2.  UTF-8
    Self.XmlDoc &= XMLStringToDOM(TXM::XmlFileToStrUTF(xStr_))  ! 3.    ANSI
    Self.XmlDoc &= XMLStringToDOM(TXM::StrAnsiToUTF(   xStr_))  ! 4.  ANSI
  end

  If Self.XmlDoc &= Null
     TXM::Mess('   XML   -   !','ToyXML.Init')
     Self.FlagInit = False
  else
     Self.ClearIndicator(xProgress_)  !  
     Self.FlagInit = True             !    !
  end

  Self.TagSeparator = '/'             !      

  Return Self.FlagInit

!    
ToyXML.Kill          Procedure
  Code

  If Not (Self.qDomList &= Null) then Free(Self.qDomList).  !  DOM  
  If Not (Self.qRules   &= Null) then Self.FreeRules().     !        
  If Not (Self.qFiles   &= Null) then Self.FreeFiles().     !   
  If Not (Self.qNames   &= Null) then Free(Self.qNames).    !     
  If Not (Self.qGroup   &= Null) then Free(Self.qGroup).    !     

  If Not (Self.XmlDoc &= Null)  !    (  )
     Self.XmlDoc.Release()
     Self.XmlDoc &= Null
  end

  Self.FlagInit = False  !  DOM   -     ...

!     XML
ToyXML.PrepareXML    Procedure(*Group gGroup,String sRootTag) !,Byte,Proc
Loc:RetValue      Byte(False)
Loc:NodeList      &NodeList,Auto
Loc:Index         Long,Auto
Loc:NameTag       CString(TXM::LenTagLone)  !  

  Code
  Self.BasicGroup &= Null       !    

  Clear(gGroup)                 !   
  Free(Self.qDomList)

  If Not (Self.XmlDoc &= Null)  !   
    !ViewXML(Self.XmlDoc)       !   XML DEBUG

     !        
     Loc:NameTag   = TXM::ANSItoUTF8(sRootTag)
     Loc:NodeList &= Self.XmlDoc.getElementsByTagName(Loc:NameTag)
     If Not (Loc:NodeList &= Null)
        Loop Loc:Index = 0 to Loc:NodeList.getLength() - 1
          FillDOMQueue(Loc:NodeList.Item(Loc:Index),Self.qDomList)  !     
        end
        Loc:NodeList.Release()
     end

     Self.AllRecord = Records(Self.qDomList)         !    
     If Self.AllRecord > 0                           !   
        Self.GroupToNames('',gGroup)                 !      (  Self.BasicGroup &= gGroup)
        Loc:RetValue = True                          !    
     end  ! If Self.AllRecord > 0

  elsIf Self.DebugMode then TXM::Mess('  XML  ','PrepareXML')
  end  ! If Not (Loc:XmlDoc &= Null)

  Return Loc:RetValue

!     ()
ToyXML.ToGroup       Procedure(*Group gGroup,String sRootTag) !,Byte,Proc
Loc:RetValue      Byte(False)
Loc:NameTag       CString(TXM::LenTagLone)  !  
Loc:IgnoreLevel   Long(0)

  Code
  If Self.PrepareXML(gGroup,sRootTag)

     Self.XmlCount = 1                            !     
     Loop While(Self.XmlCount <= Self.AllRecord)  !   
       Get(Self.qDomList,Self.XmlCount)

       If InList(Self.qDomList.Node.GetNodeName(),'#document','#text','#comment','#cdata-section') = 0
                                                  !    ( )
          Loc:NameTag = Lower(TXM::UTF8toANSI(Self.qDomList.Node.getLocalName()))

          If    Self.GetRule(Loc:NameTag,'Ignore') = True then Loc:IgnoreLevel = Self.qDomList.Level
          elsIf Self.qDomList.Level <= Loc:IgnoreLevel    then Loc:IgnoreLevel = 0.

          If Loc:IgnoreLevel = 0                  !    -  
             If Self.GetXmlValue(gGroup,sRootTag,Loc:NameTag) then Loc:RetValue = True.
          end
       end

       Self.XmlCount += 1    !  
       Self.ShowIndicator()  !   
     end  !  Loop While(Self.XmlCount

     Free(Self.qDomList)

  elsIf Self.DebugMode then TXM::Mess('  XML  ','ToGroup')
  end  ! If Self.PrepareXML(gGroup,sRootTag)
  
  Return Loc:RetValue

!     ()
ToyXML.ToQueue       Procedure(*Queue qList,String sRootTag)  !,Long,Proc
Loc:RetValue      Long(0)                   ! -  
Loc:NameTag       CString(TXM::LenTagLone)  !  
Loc:StartLevel    Long(0)
Loc:FlagData      Byte(False)               !   qList   

  Code
  If Self.PrepareXML(qList,sRootTag)

     Self.XmlCount = 1                             !     
     Loop While(Self.XmlCount <= Self.AllRecord)   !   
       Get(Self.qDomList,Self.XmlCount)

       If InList(Self.qDomList.Node.GetNodeName(),'#document','#text','#comment','#cdata-section') = 0
                                                   !    ( )
          Loc:NameTag = Lower(TXM::UTF8toANSI(Self.qDomList.Node.getLocalName()))

          If Loc:NameTag = Lower(sRootTag)         !      
             Do AddNewRecord                       !        
             Loc:StartLevel = Self.qDomList.Level  !       
          end

          If Loc:StartLevel > 0                    !     -  
             If Self.GetXmlValue(qList,sRootTag,Loc:NameTag) then Loc:FlagData = True.
                                                   !     (    !)
          elsIf Loc:StartLevel > 0 then Loc:StartLevel = 0  
          end
       end

       Self.XmlCount += 1      !  
       Self.ShowIndicator()    !   
     end

     Do AddNewRecord           !         ()
     Free(Self.qDomList)

  elsIf Self.DebugMode then TXM::Mess('  XML  ','ToQueue')
  end  ! If Self.PrepareXML(gGroup,sRootTag)

  Return Loc:RetValue

AddNewRecord  Routine          !        

  If Loc:FlagData = True       !     ( ..    )
     Add(qList)                ! -    
     If ~ErrorCode()
        Loc:RetValue += 1      !       (Records()  , ..    )
        Loc:FlagData  = False  !      
     elsIf Self.DebugMode
        TXM::Mess('  . : ' & Loc:NameTag,'Do AddNewRecord')
     end
  end

  Clear(qList)                 !    (     )
  Self.WriteIdRecord('','')    !    ID      

!    Xml   
ToyXML.GetXmlValue    Procedure(*Group gGroup,String sRootTag,String sNameTag) !,Byte,Proc
xFullNameTag          CString(TXM::LenTagFull)    !   
gChild                Group(TXM::G_Child).        !   
xRetValue             Byte(False)

  Code
  xFullNameTag = Self.GetFullTag()                !        qDomList
                                                  !    
  If Self.FlagChild and (xFullNameTag = Lower(sRootTag) & Self.TagSeparator & Self.GetRule(sNameTag,'IsList',gChild))

     If Self.qDomList.Node.hasAttributes()        !      

        Clear(gChild.ChildQue)                    !        
                                                  !       
        If Self.GetAttValue(gChild.ChildQue,sNameTag,gChild.Tag) then Self.AddChildList(gChild,sNameTag).

     elsIf Self.qDomList.Node.hasChildNodes()     !     
        Self.GetChildList(gChild,sNameTag)
     end
  else                                          
     If Self.qDomList.Node.hasAttributes()        !      
        If Self.GetAttValue(gGroup,xFullNameTag,'') then xRetValue = True.
     end
     If Self.qDomList.Node.hasChildNodes()        !      
        If Self.GetTagValue(gGroup,xFullNameTag,sNameTag) then xRetValue = True.
     end
  end

  Return xRetValue

!      
ToyXML.GetChildList   Procedure(*TXM::G_Child gChild,String sNameTag)
xNodeList             &NodeList,Auto
xDomList              Queue(DOMQueue).            !  DOM  
xIndex                Long,Auto
xColumn               Long,Auto
xAllRecord            Long,Auto
xNameTag              CString(TXM::LenTagLone)    !  
xFieldRef             Any

  Code
  Free(xDomList)                                  !       
  xNodeList &= Self.qDomList.Node.getChildNodes()
  If Not (xNodeList &= Null)
     Loop xIndex = 0 to xNodeList.getLength() - 1
       FillDOMQueue(xNodeList.Item(xIndex),xDomList)
     end
     xNodeList.Release()
  end

  xAllRecord = Records(xDomList)                  !     
  If xAllRecord > 0 then xIndex = 1               !   1-  

     Loop While(xIndex <= xAllRecord)             !    
       Get(xDomList,xIndex)

       xNameTag = Lower(TXM::UTF8toANSI(xDomList.Node.getLocalName()))  !    ( )
       If InList(xNameTag,'#document','#text','#comment','#cdata-section','') = 0

          Get(xDomList,xIndex + 1)     !     (         )
          If ~ErrorCode() and InList(xDomList.Node.GetNodeName(),'#text','#cdata-section')

             xIndex += 1

             xColumn = Self.WhereByName(gChild.Tag,sNameTag & Self.TagSeparator & xNameTag)  !       
             If xColumn > 0
                Clear(gChild.ChildQue)

                xFieldRef &= What(gChild.ChildQue,xColumn)  !     
                If Not (xFieldRef &= Null) then xFieldRef = TXM::UTF8toANSI(xDomList.Node.GetNodeValue()).

                Self.AddChildList(gChild,sNameTag)          !          
             end  ! If xColumn > 0
          end  ! If ~ErrorCode()
       end  ! If InList(xNameTag

       xIndex += 1    !  
     end  !  Loop While(

     Free(xDomList)
  end  ! If xAllRecord > 0

!          
ToyXML.AddChildList   Procedure(*TXM::G_Child gChild,String sNameTag)
xLinkNum              Long,Auto                   !      
xLinkRef              Any                         !     

  Code                                            
  xLinkNum = Self.WhereByName(gChild.Tag,sNameTag & Self.TagSeparator & gChild.IdRecTag)

  If xLinkNum > 0
     xLinkRef &= What(gChild.ChildQue,xLinkNum)   !     (     XML)
     If Not (xLinkRef &= Null)
        xLinkRef = gChild.IdRecVal
        Add(gChild.ChildQue,Who(gChild.ChildQue,xLinkNum))
     end

  elsIf gChild.IdRecTag = ''
     If Self.DebugMode then TXM::Mess(' IdRecTag   . : ' & sNameTag,'SetLinkField').
  end

!      
ToyXML.GetAttValue    Procedure(*Group gGroup,String sNameTag,String sListTag) !,Byte,Proc
xTagNNP               &NamedNodeMap               !   
xCurAtrNode           &Node,Auto                  ! 
xAttrIndex            Long,Auto
xAttrName             CString(TXM::LenTagLone)
xColumn               Long,Auto
xFieldRef             Any
xRetValue             Byte(False)

  Code
  xTagNNP &= Self.qDomList.Node.GetAttributes()
  If Not (xTagNNP &= Null)                                                !     
     Loop xAttrIndex = 0 to (xTagNNP.GetLength() - 1)                     !    

       xCurAtrNode &= xTagNNP.Item(xAttrIndex)                            !  
       xAttrName    = Lower(TXM::UTF8toANSI(xCurAtrNode.getLocalName()))  !   ( )
                                                                          !        +        XML
       xColumn      = Self.WhereByName(sListTag,sNameTag & Self.TagSeparator & xAttrName,Choose(sListTag = '',True,False))
       If xColumn > 0                                                     !     
          xFieldRef &= What(gGroup,xColumn)                               !    
          If Not (xFieldRef &= Null)
             If IsString(xFieldRef) then xFieldRef = TXM::UTF8toANSI(xCurAtrNode.GetNodeValue())
             else                        xFieldRef =                 xCurAtrNode.GetNodeValue().

             Self.WriteIdRecord(xAttrName,xFieldRef)                      !   ID  (   )
             xRetValue = True                                             !      
          end
       end  ! If xColumn > 0
     end  ! Loop xAttrIndex = 0 to

     xTagNNP.Release()
  end  ! If Not (xTagNNP &= Null)

  Return xRetValue

!      
ToyXML.GetTagValue    Procedure(*Group gGroup,String sFullTag,String sNameTag) !,Byte,Proc
xColumn      Long,Auto
xFieldRef    Any
xRetValue    Byte(False)
  Code                                             ! ,      
  Get(Self.qDomList,Self.XmlCount + 1)             !     (         )
  If ~ErrorCode() and InList(Self.qDomList.Node.GetNodeName(),'#text','#cdata-section')

     Self.XmlCount += 1

     xColumn = Self.WhereByName('',sFullTag,True)  !        +        XML
     If xColumn > 0                                !     

        xFieldRef &= What(gGroup,xColumn)          !    
        If Not (xFieldRef &= Null)
                                                   !     
           If Self.GetRule(Who(gGroup,xColumn),'IsFile') = True
              If Not (Self.qFiles &= Null)
                 Clear(Self.qFiles)
                 Self.qFiles.ID      = TXM::GetGUID()
                 Self.qFiles.Content = FromBase64(Self.qDomList.Node.GetNodeValue())
                 Add(Self.qFiles,Self.qFiles.ID)
                 If ~ErrorCode() then xFieldRef = Self.qFiles.ID.
              end

           elsIf IsString(xFieldRef) then xFieldRef = TXM::UTF8toANSI(Self.qDomList.Node.GetNodeValue())
           else                           xFieldRef =                 Self.qDomList.Node.GetNodeValue().

           Self.WriteIdRecord(sNameTag,xFieldRef)  !   ID  (   )
           xRetValue = True                        !      
        end
     end  ! If xColumn > 0
  end  ! If ~ErrorCode()

  Return xRetValue

!   ID     
ToyXML.WriteIdRecord  Procedure(String sNameTag, String sValueTag)
xCount  Long,Auto
  Code
  If Self.FlagChild                                !       
     Loop xCount = 1 to Records(Self.qRules)       !    
       Get(Self.qRules,xCount)                     !   , ..       !

       If InList(Self.qRules.Child.IdRecTag,'',sNameTag)
          Self.qRules.Child.IdRecVal = sValueTag
          Put(Self.qRules)
       end
     end
  end

!       
ToyXML.FreeRules      Procedure
  Code
  Free(Self.qRules)                     !   
  Free(Self.qNames)                     !     
  Free(Self.qGroup)                     !     

  Self.FlagChild = False                !     (False ->   )
  Self.BasicGroup &= Null               !     (    Self.qNames)

!      
ToyXML.SetRule        Procedure(String sFieldName,String sRuleName,? fRuleValue,<*Queue qChildList>)
xShortTag  CString(TXM::LenTagLone)  !   
  Code

  xShortTag = Lower(Self.GetShortTag(sFieldName))  !   

  Clear(Self.qRules)
  Self.qRules.FieldName = xShortTag
  Get(Self.qRules,Self.qRules.FieldName)
  If ErrorCode()  !     -> 
     Clear(Self.qRules)
     Self.qRules.FieldName = xShortTag
     Add(Self.qRules,Self.qRules.FieldName)
  end

  Case Lower(Clip(Left(sRuleName)))
  Of 'isfile'
     Self.qRules.IsFile = fRuleValue
     Put(Self.qRules,Self.qRules.FieldName)

  Of 'ignore'
     Self.qRules.Ignore = fRuleValue
     Put(Self.qRules,Self.qRules.FieldName)

  Of 'islist'
     If Not Omitted(qChildList)
        Self.qRules.Child.Tag       = Lower(sFieldName)         !      
        Self.qRules.Child.IdRecTag  = Lower(fRuleValue)         !    ID    
        Self.qRules.Child.IdRecVal  = ''                        !  ID 
        Self.qRules.Child.ChildQue &= qChildList                !     (  IdRecVal   IdRecTag)
        Put(Self.qRules,Self.qRules.FieldName)
        If ~ErrorCode()
           Self.GroupToNames(Self.qRules.Child.Tag,qChildList)  !      (    !)
           Self.FlagChild = True                                !       (       )
        end
     end  ! If Not Omitted(qChildList)
  end  ! Case Lower(Clip(Left(sRuleName)))

!       
!  !   -       If GetRule() = True !
ToyXML.GetRule        Procedure(String sFieldName,String sRuleName,<*TXM::G_Child gChild>) !,String
RetValue  CString(101)
  Code
  If Not Omitted(gChild) then Clear(gChild).  !   

  Clear(Self.qRules)
  Self.qRules.FieldName = Lower(sFieldName)
  Get(Self.qRules,Self.qRules.FieldName)
  If ErrorCode() then Clear(Self.qRules)
  else
     Case Lower(sRuleName)
     Of 'isfile'
        RetValue = Self.qRules.IsFile
     Of 'ignore'
        RetValue = Self.qRules.Ignore
     Of 'islist'
        If Not (Self.qRules.Child.ChildQue &= Null Or Omitted(gChild))
           gChild   = Self.qRules.Child     !    
           RetValue = Self.qRules.Child.Tag
        end
     end
  end

  Return RetValue

!      BLOB 
ToyXML.FreeFiles      Procedure()
xCount  Long,Auto
  Code
  If Records(Self.qFiles) > 0
     Loop xCount = Records(Self.qFiles) to 1 by -1
       Get(Self.qFiles,xCount)

       If Not (Self.qFiles.Content &= Null) then Self.qFiles.Content &= Null.
       Delete(Self.qFiles)
     end
     Free(Self.qFiles)  !  
  end

!     qFiles  ID    BLOB 
ToyXML.ContentToBlob  Procedure(String sID_,Blob xBlob_)
  Code
  If Clip(sID_) <> ''
     Clear(Self.qFiles)
     Self.qFiles.ID = Clip(sID_)
     Get(Self.qFiles,Self.qFiles.ID)
     If ~ErrorCode() and ~(Self.qFiles.Content &= Null)
        xBlob_[0:(Len(Self.qFiles.Content) - 1)] = Self.qFiles.Content
        Self.qFiles.Content &= Null
        Delete(Self.qFiles)
     end
  end

!     qFiles  ID    
ToyXML.ContentToFile  Procedure(String sID_,String sFileName)
RetValue  Byte(False)
  Code
  If (Clip(sID_) <> '') and (Clip(sFileName) <> '')
     Clear(Self.qFiles)
     Self.qFiles.ID = Clip(sID_)
     Get(Self.qFiles,Self.qFiles.ID)
     If ~ErrorCode() and ~(Self.qFiles.Content &= Null)
        RetValue = TXM::WriteStrToFile(sFileName,Self.qFiles.Content)
        Self.qFiles.Content &= Null
        Delete(Self.qFiles)
     end
  end
  Return RetValue

!         qDomList
ToyXML.GetParentTag   Procedure  !,String
xParentTag   CString(TXM::LenTagFull)
xParentNode  &Node,Auto   !  
  Code
  xParentTag   = ''
  xParentNode &= Self.qDomList.Node

  Loop Self.qDomList.Level - 1 times
    xParentNode &= xParentNode.GetParentNode()
    If    xParentNode &= Null                            then Break  ! , ..  
    elsIf Lower(xParentNode.GetNodeName()) = '#document' then Break  !       
    else
       xParentTag = Lower(TXM::UTF8toANSI(xParentNode.GetLocalName())) & Choose(xParentTag = '','',Self.TagSeparator) & xParentTag
      !Message('Tag : ' & Lower(TXM::UTF8toANSI(xParentNode.GetLocalName())) & '|Full: ' & xParentTag)
    end
  end

  Return xParentTag

!        qDomList
ToyXML.GetFullTag     Procedure  !,String
xParentTag   CString(TXM::LenTagFull)
  Code
  xParentTag = Self.GetParentTag()
  Return xParentTag & Choose(xParentTag = '','',Self.TagSeparator) & Lower(TXM::UTF8toANSI(Self.qDomList.Node.getLocalName()))

!       
ToyXML.GetParentField Procedure(*Group gGroup,Long lColumn)  !,String
xParentField   CString(TXM::LenTagFull)
xIndex         Long(1)
xGrRef         &Group
xGrCol         Long,Auto
  Code
  xParentField = ''
  Loop
    If    Who(    gGroup,xIndex) = '' then Break  !  
    elsIf IsGroup(gGroup,xIndex)                  ! 

       xGrRef &= GetGroup(gGroup,xIndex)
       xGrCol  = 1
       Loop
         If Who(xGrRef,xGrCol) = '' then Break
         elsIf (xIndex + xGrCol) = lColumn        !    
            xParentField = xParentField & Choose(xParentField = '','',Self.TagSeparator) & Lower(Who(gGroup,xIndex))
            Break
         end
         xGrCol += 1
       end
    end

    xIndex += 1
    If xIndex = lColumn then Break.
  end
 
  Return xParentField

!        (AntiWhere)
ToyXML.GetFullField   Procedure(*Group gGroup,Long lColumn)  !,String
xParentField   CString(TXM::LenTagFull)
  Code
  xParentField = Self.GetParentField(gGroup,lColumn)
  Return xParentField & Choose(xParentField = '','',Self.TagSeparator) & Lower(Who(gGroup,lColumn))

!        ( Ignore  )
ToyXML.GroupToNames   Procedure(String sListTag,*Group gGroup)
xColumn    Long,Auto
xFullPath  CString(TXM::LenTagFull)
!xIndex     Long,Auto  ! Plan B
!xFieldRef  Any
!xGroupRef  &Group
!xFullName  CString(TXM::LenTagFull)
  Code

  If Not Self.FlagChild  !    
     Free(Self.qNames)   ! -    
     Free(Self.qGroup)   ! -   
  else                   !       
     Loop xColumn = Records(Self.qNames) to 1 by -1
       Get(Self.qNames,xColumn)
       If Not ErrorCode() and Self.qNames.ChildTag = sListTag then Delete(Self.qNames).
     end
  end

  ! Plan A
  xColumn = 0
  Self.GroupDeadLoop(sListTag,gGroup,xFullPath,xColumn)
  If sListTag = '' then Self.BasicGroup &= gGroup.  !   

!     ! Plan B
!     xColumn = 1
!     Loop                                           !     
!       If Who(gGroup,xColumn) = '' then Break       !    
!       elsIf Self.GetRule(Who(gGroup,xColumn),'Ignore') = True
!          If IsGroup(gGroup,xColumn)                !    -
!             xGroupRef &= GetGroup(gGroup,xColumn)  !     
!             xIndex = 1
!             Loop
!               xFieldRef &= What(xGroupRef,xIndex)
!               If xFieldRef &= Null then Break else xIndex += 1.
!             end
!
!             xColumn += (xIndex - 1)
!          end
!
!       elsIf Not IsGroup(gGroup,xColumn)            !    ( )
!          xFieldRef &= What(gGroup,xColumn)         
!          If xFieldRef &= Null then Break           !  !      -  
!          else                                      !       GetAttValue  GetTagValue
!                                                    !   
!             xFullName = Self.GetFullField(gGroup,xColumn)
!
!             If Self.DebugMode = True               !      
!                Clear(Self.qNames)                  !     -    ! :(
!                Self.qNames.ChildTag = sListTag
!                Self.qNames.FullName = xFullName
!                Get(Self.qNames,Self.qNames.ChildTag,Self.qNames.FullName)
!                If Not ErrorCode() then TXM::Mess('   : |' & xFullName,'GroupToNames').
!             end
!
!             Clear(Self.qNames)
!             Self.qNames.ChildTag = sListTag        !  
!             Self.qNames.FullName = xFullName       !   
!             Self.qNames.Number   = xColumn         !  
!             Add(Self.qNames,Self.qNames.ChildTag,Self.qNames.FullName)
!            !Message(Self.qNames.Number & '|' & Self.qNames.FullName)
!          end
!       end
!
!       xColumn += 1
!     end  ! Loop

  !'/'
!  Message('sListTag = ' & sListTag)

!      
ToyXML.GroupDeadLoop  Procedure(String sListTag,*Group gGroup,String sPath,Long lColumn)  !,Long
xGrRef    &Group
xGrCol     Long(1)
xGrAll     Long,Auto
xFullPath  CString(TXM::LenTagFull)
  Code
  lColumn += 1  !  !     GROUP !

  !Message('sListTag = ' & sListTag & '|gGroup' & gGroup & '||lColumn = ' & lColumn & '|Who(gGroup,lColumn) = ' & Who(gGroup,lColumn))

  If Who(gGroup,lColumn) = '' then Return 0
  elsIf Self.GetRule(Who(gGroup,lColumn),'Ignore') = True
     If IsGroup(gGroup,lColumn)             !    -
        xGrRef &= GetGroup(gGroup,lColumn)  !     
        Loop
          If Who(xGrRef,xGrCol) = '' then Break else xGrCol += 1.
        end
        lColumn += (xGrCol - 1)  !   
     end

  elsIf IsGroup(gGroup,lColumn)  !  ( )
     xFullPath = sPath & Choose(sPath = '','',Self.TagSeparator) & Lower(Who(gGroup,lColumn))

     If sListTag = ''
        Clear(Self.qGroup)       !   
        Self.qGroup.FullName = xFullPath
        Self.qGroup.Number   = lColumn   !    
        Add(Self.qGroup,Self.qGroup.Number)
     end

     xGrRef   &= GetGroup(gGroup,lColumn)
     Loop
       If Who(xGrRef,xGrCol) = '' then Break
       else
          xGrAll   = Self.GroupDeadLoop(sListTag,gGroup,xFullPath,lColumn)
          xGrCol  += xGrAll      !   -  
          lColumn += xGrAll
       end
     end
  else                           !  (  )
     Clear(Self.qNames)               !    (   )
     Self.qNames.FullName = sPath & Choose(Who(gGroup,lColumn) = '#','',Self.TagSeparator & Lower(Who(gGroup,lColumn)))
     !Self.qNames.FullName = sPath & Self.TagSeparator & Lower(Who(gGroup,lColumn))

     Self.qNames.ChildTag = sListTag  !  
     Self.qNames.Number   = lColumn   !  
     Add(Self.qNames,Self.qNames.ChildTag,Self.qNames.FullName)

     !If Lower(sListTag) = Lower('/')
     !   Message('ChildTag = ' & Self.qNames.ChildTag & '|Lower(Who(gGroup,lColumn)) = ' & Lower(Who(gGroup,lColumn)) & '|FullName = ' & Self.qNames.FullName)
     !end
  end

  Return xGrCol

!         +     
ToyXML.WhereByName Procedure(String sListTag,String sFullName,Byte FixSpecified = False) !,Long
  Code
  Clear(Self.qNames)
  Self.qNames.ChildTag = sListTag   !     
  Self.qNames.FullName = sFullName  !   
  Get(Self.qNames,Self.qNames.ChildTag,Self.qNames.FullName)
  If ErrorCode() then Clear(Self.qNames)
  elsIf FixSpecified = True         !     
     Self.qNames.Specified = True   !    XML 
     Put(Self.qNames)
  end
  Return Self.qNames.Number

!     XML 
ToyXML.SpecifiedTag Procedure(*? hzLabel)  !,Byte
  Code
  Clear(Self.qNames)
  If Not (Self.BasicGroup &= Null)  !     
                                    !   
     Self.qNames.FullName = Self.GetFullField(Self.BasicGroup,Where(Self.BasicGroup,hzLabel))
     Get(Self.qNames,Self.qNames.ChildTag,Self.qNames.FullName)
     If ErrorCode() then Clear(Self.qNames).
  end

  Return Self.qNames.Specified      !     XML 

!        
ToyXML.ValueByName  Procedure(String sFullName)  !,?
xIndex    Long,Auto
xFieldRef Any
xRetValue Any
  Code
  xRetValue = ''

  xIndex    = Self.WhereByName('',Lower(sFullName),False)
  If xIndex > 0                                    !       
     If Not (Self.BasicGroup &= Null)              !    

        xFieldRef &= What(Self.BasicGroup,xIndex)  !    
        If Not (xFieldRef &= Null) then xRetValue = xFieldRef.
     end
  end

  Return xRetValue

!          
ToyXML.ValueByGroup Procedure(*Group gGroup,String sField) !,?
  Code
  If Not (Self.BasicGroup &= Null)        !    
     Clear(Self.qGroup)                   !       
     Self.qGroup.Number = Where(Self.BasicGroup,gGroup)  
     Get(Self.qGroup,Self.qGroup.Number)  !     ->        
     If Not ErrorCode() then Return Self.ValueByName(Self.qGroup.FullName & Self.TagSeparator & sField).
  end
  Return ''

!      
ToyXML.ClearIndicator Procedure(UShort xProgress_ = 0)
  Code
  If xProgress_ > 0
     Self.CurPercent               = 0
     Self.Progress                 = xProgress_
     Self.Progress{Prop:Progress}  = Self.CurPercent
     Self.Progress{Prop:RangeHigh} = 100
     Self.Progress{Prop:Hide}      = False
     Display(Self.Progress)
  else
     Self.Progress = 0
  end

  Self.AllRecord = 0  !    
  Self.XmlCount  = 0  !     

!   
ToyXML.ShowIndicator Procedure
newPercent  Long, Auto
  Code
  If (Self.Progress > 0) and (Self.AllRecord > 0)
     newPercent = (Self.XmlCount * 100 / Self.AllRecord)
     If Self.CurPercent < newPercent
        Self.CurPercent = newPercent
        Self.Progress{Prop:Progress} = Self.CurPercent
        Display(Self.Progress)
     end
  end

!       
ToyXML.GetShortTag  Procedure(String sTag) !, String
xLen  Long,Auto
xPos  Long,Auto
  Code
  xLen = Len(Clip(sTag))
  xPos = InString(Self.TagSeparator,sTag,-1,xLen)
  Return Sub(sTag,xPos + 1,xLen - xPos)

! ---  XML

PushXML.Construct     Procedure
  Code
  Self.XmlBuffer &= NewDynStr()       !    XML
  Self.qAttr     &= New(TXM::Q_Attr)  !    

PushXML.Destruct      Procedure
  Code
  Self.Kill  !    

  If Not (Self.XmlBuffer &= Null)  !    XML
     DisposeDynStr(Self.XmlBuffer)
     Self.XmlBuffer &= Null
  end

  If Not (Self.qAttr &= Null) then Dispose(Self.qAttr).  !    

!   
PushXML.Init          Procedure(byte bEncoding = False,byte bLineBreak = False,UShort xProgress = 0)  !,Byte,Proc
  Code
  Self.Kill                    !   

  Self.Encoding  = bEncoding   ! Windows-1251 = False / UTF-8 = True
  Self.LineBreak = bLineBreak  !  
  Return True

!    
PushXML.Kill          Procedure
  Code
  If Not (Self.XmlBuffer &= Null) then Self.XmlBuffer.Kill(). !    XML
  If Not (Self.qAttr     &= Null) then Free(Self.qAttr).      !    

  Self.Encoding  = False
  Self.LineBreak = False

!  XML   
PushXML.SaveAs        Procedure(String sFileName) !,Byte,Proc
  Code
  If Self.Encoding = True then Return TXM::WriteStrToFile(sFileName,TXM::ANSItoUTF8(Self.XmlBuffer.Str()))
                          else Return TXM::WriteStrToFile(sFileName,                Self.XmlBuffer.Str() ).

!   
PushXML.AddEndLine    Procedure
  Code
  If Self.LineBreak = True then Self.XmlBuffer.Cat('<13,10>').

!   
PushXML.AddStr        Procedure(String sText)
  Code
  Self.XmlBuffer.Cat(Clip(sText))
  Self.AddEndLine

!   
PushXML.AddCap        Procedure
  Code
  Self.XmlBuffer.Cat('<?xml version="1.0" encoding="' & Choose(Self.Encoding = True,'UTF-8','Windows-1251') & '" ?>')
  Self.AddEndLine

!  
PushXML.AddRem        Procedure(String sText)
  Code
  Self.XmlBuffer.Cat('<!-- ' & Clip(sText) & ' -->')
  Self.AddEndLine

!   ()
PushXML.WriteTag      Procedure(String sTag,<String sValue>,Byte bFlagClose = False) !,Private
xIndex  Long,Auto
  Code
  Self.XmlBuffer.Cat('<' & Clip(sTag))

  If Records(Self.qAttr) > 0
     Loop xIndex = 1 to Records(Self.qAttr)
       Get(Self.qAttr,xIndex)
       Self.XmlBuffer.Cat(' ' & Self.qAttr.Name & '="' & TXM::Escape(Self.qAttr.Value)& '"')
     end
     Free(Self.qAttr)
  end

  If bFlagClose = True then Self.XmlBuffer.Cat('/>')   !      !
  else
     Self.XmlBuffer.Cat('>')
     If Not Omitted(sValue) then Self.XmlBuffer.Cat(TXM::Escape(sValue) & '</' & Clip(sTag) & '>').
  end

  Self.AddEndLine

!   
PushXML.Closed        Procedure(String sTag,<String sValue>)
  Code
  If Omitted(sValue) then Self.WriteTag(sTag,,True)    !    
                     else Self.WriteTag(sTag,sValue).  !    

!   
PushXML.Opened        Procedure(String sTag)  !,Byte
  Code
  Self.WriteTag(sTag)
  Return True

!    
PushXML.EndTag        Procedure(String sTag)
  Code
  Self.XmlBuffer.Cat('</' & Clip(sTag) & '>')
  Self.AddEndLine

!      Base64
PushXML.AddFile       Procedure(String sTag,String sFileName)
  Code
  Self.XmlBuffer.Cat('<' & sTag & '>' & ToBase64(TXM::LoadStrFromFile(sFileName)) & '</' & sTag & '>')
  Self.AddEndLine

!   CData
PushXML.AddCData      Procedure(String sTag,String sValue)
  Code
  Self.XmlBuffer.Cat('<' & sTag & '><![CDATA[' & Clip(sValue) & ']]></' & sTag & '>')
  Self.AddEndLine

!  elsIf xVid_ = 9   ! CDATA BASE64
!     xBuffer_.Cat('<![CDATA[' & Clip(xString_) & ']]>')

!                              
PushXML.SetAtr        Procedure(String sName,String sValue,Byte bAddNotValue = True)
  Code
  If (Clip(sName) <> '') and (bAddNotValue Or Clip(sValue) <> '')
     Self.qAttr.Name  = Clip(sName)
     Self.qAttr.Value = Clip(sValue)
     Add(Self.qAttr)
  end

!       ( ,  )
PushXML.NewAtr        Procedure(String sName,String sValue,Byte bAddNotValue = True)
  Code
  If Records(Self.qAttr) > 0 then Free(Self.qAttr).
  Self.SetAtr(sName,sValue,bAddNotValue)

! ---    

!   5.49 EDO::G_FIOTip ()
PushXML.EdoSplitFIO   Procedure(String sName)
xFIO    CString(181)
xL1     CString( 61)
xL2     CString( 61)
xL3     CString( 61)
xFind   Long,Auto
  Code
  xFIO = Clip(Left(sName))

  !    
  If    Lower(Sub(xFIO,1,31)) = '  ' then xFIO = Clip(Left(Sub(xFIO,32,Len(xFIO) - 31)))
  elsIf Lower(Sub(xFIO,1,03)) = ' '                             then xFIO = Clip(Left(Sub(xFIO,04,Len(xFIO) - 03))).

  !    
  xFind = InString(' ',xFIO,1,1)     !  :   

  If xFind = 0 then xL1 = xFIO       !   -  
  else
     xL1  = Clip(Sub(xFIO,1,xFind - 1))                              ! 
     xFIO = Clip(Left(Sub(xFIO,xFind + 1,Len(xFIO) - xFind)))        !  

     xFind = Instring('.',xFIO,1,1)  !  :    (     )
     If xFind > 1
        xL2  = Clip(Sub(xFIO,1,xFind))                               !     
        xFIO = Clip(Left(Sub(xFIO,xFind + 1,Len(xFIO) - xFind)))     !  

        xFind = Instring('.',xFIO,1,1)                               !    
        If xFind > 1 then xL3 = Clip(Sub(xFIO,1,xFind)).             !     

     else                            !   /    -      (   )
        xFind = Instring(' ',xFIO,1,1)
        If xFind > 1
           xL2   = Clip(Sub(xFIO,1,xFind - 1))                       ! 
           xFIO  = Clip(Left(Sub(xFIO,xFind + 1,Len(xFIO) - xFind))) !  

           xFind = Instring(' ',xFIO,1,1)
           If xFind > 1 then xL3 = Clip(Sub(xFIO,1,xFind - 1))       !   
           else
              xFind = Instring(',',xFIO,1,1)
              If xFind > 1 then xL3 = Clip(Sub(xFIO,1,xFind - 1))    !   
              else
                 xL3 = xFIO                                          !  ()
              end
           end
        else
           xL2 = xFIO                                                !  ()
        end
     end
  end

  !             
  Self.NewAtr('',  Choose(xL1 = '','',xL1))
  Self.SetAtr('',      Choose(xL2 = '','',xL2))
  Self.SetAtr('', xL3, False)
  Self.Closed('')

!   5.34   ()
PushXML.EdoIdSv       Procedure
  Code
  If Self.Opened('')         ! 5.34

     Case Self.IdSv.OwnerShip    ! <-  
     Of 1  !  
        Self.NewAtr('',   Self.IdSv.Name)
        Self.SetAtr('',     Self.IdSv.INN)
        Self.SetAtr('',       Self.IdSv.KPP,False)
        Self.Closed('')

     Of 2  !  
        Self.NewAtr('',     Self.IdSv.INN)
        Self.SetAtr('',Self.IdSv.DocSv,    False)
        Self.SetAtr('',  Self.IdSv.OtherInfo,False)
        If Self.Opened('')
           Self.EdoSplitFIO(Self.IdSv.Name)
           Self.EndTag('')
        end

     Of 3 To 4 !   / 
        Self.NewAtr('',         Self.IdSv.INN,      False)
        Self.SetAtr('',Self.IdSv.DocSv,    False)
        Self.SetAtr('',      Self.IdSv.OtherInfo,False)
        If Self.Opened('')
           Self.EdoSplitFIO(Self.IdSv.Name)
           Self.EndTag('')
        end

     else  !  -> 
        Self.NewAtr('',   Self.IdSv.Name)
        Self.SetAtr('',  Self.IdSv.OtherInfo,False)
        Self.Closed('')
     end

     Self.EndTag('')
  end

!   5.39  ()
PushXML.EdoAddress  Procedure(Byte bSRF, String sAddressText)
  Code
  If Self.Opened('')        ! 5.39

     If Clip(sAddressText) = ''  ! 5.40
        Self.NewAtr('',Format(Choose(InRange(bSRF,1,99) = False,99,bSRF),@n02))
        Self.Closed('')
     else                        ! 5.41
        Self.NewAtr('',  '643')
        Self.SetAtr('',sAddressText)
        Self.Closed('')
     end

     Self.EndTag('')
  end

!   5.42   ()
PushXML.EdoContact Procedure(String sPhone, String sEMail)
  Code
  If (Clip(sPhone) <> '') Or (Clip(sEMail) <> '')
     Self.NewAtr('',     sPhone, False)
     Self.SetAtr('', sEMail, False)
     Self.Closed('')
  end

!!!   5.37   ()
PushXML.EdoBank    Procedure
  Code
  If Clip(Self.Bank.PaymAccount) <> ''  !     

     Self.NewAtr('',Self.Bank.PaymAccount)
     If Self.Opened('')

        If (Clip(Self.Bank.SvBank.Name)        <> '') Or |  !  
           (Clip(Self.Bank.SvBank.BIK)         <> '') Or |  !    ()
           (Clip(Self.Bank.SvBank.CorrAccount) <> '')       !   

           Self.NewAtr('', Self.Bank.SvBank.Name,        False)
           Self.SetAtr('',      Self.Bank.SvBank.BIK,         False)
           Self.SetAtr('',  Self.Bank.SvBank.CorrAccount, False)
           Self.Closed('')
        end

        Self.EndTag('')
     end
  end

! ---  

!        
TXM::PodpisEdo  Procedure(*EDO::G_Podpisant Podpisant,Byte bInitial = False)  !,String
xFIO  &EDO::G_FIOTip
  Code
  If    Podpisant.SvFL.FIO.Fam <> '' then xFIO &= Podpisant.SvFL.FIO  ! 
  elsIf Podpisant.SvIP.FIO.Fam <> '' then xFIO &= Podpisant.SvIP.FIO  ! 
  elsIf Podpisant.ReUL.FIO.Fam <> '' then xFIO &= Podpisant.ReUL.FIO. ! 

  If xFIO &= Null then Return ''
  else
     Return xFIO.Fam & ' ' &             Choose(bInitial = True,Upper(Sub(xFIO.Name,1,1)) & '.',xFIO.Name) & |
            Choose(xFIO.Otch <> '',' ' & Choose(bInitial = True,Upper(Sub(xFIO.Otch,1,1)) & '.',xFIO.Otch),'')
  end

!  XML     ANSI  UTF8
TXM::XmlFileToStrUTF  Procedure(*? zXMLFile_)  !,string
xCodInfo  &String
RetValue  Any
  Code
  xCodInfo    &= TXM::LoadStrFromFile(zXMLFile_)
  If xCodInfo &= Null then Return ''
  else
     RetValue = TXM::StrAnsiToUTF(xCodInfo)
     Dispose(xCodInfo)
     Return RetValue
  end

!  XML   ANSI  UTF8
TXM::StrAnsiToUTF     Procedure(*? zStr1251_)  !,string
zText   String(Len(zStr1251_))  ! Size()  *? = 4 :(
  Code
  zText = zStr1251_
  TXM::ReplaceText(zText,'encoding="Windows-1251"','encoding="UTF-8"',1)
  Return TXM::AnsiToUtf8(zText)

!    
TXM::LoadStrFromFile  Procedure(String pFileName,Long xMaxByte = 0) !,*String
Loc:FileName        CSTRING(File:MaxFileName)
Loc:SData           &STRING
Loc:hFile           HANDLE
Loc:dwBytesRead     LONG,AUTO
Loc:dwFileSize      LONG,AUTO
Loc:lpFileSizeHigh  LONG
Loc:bRead           LONG,AUTO
  Code
  Loc:FileName = Clip(pFileName)
  Loc:hFile = TXM::CreateFile(Loc:FileName,GENERIC_READ,0,0,OPEN_EXISTING,0,0)
  If Loc:hFile <> INVALID_HANDLE_VALUE
     If xMaxByte > 0 then Loc:dwFileSize = xMaxByte else Loc:dwFileSize = TXM::GetFileSize(Loc:hFile,Loc:lpFileSizeHigh).
     If Loc:dwFileSize > 0
        Loc:SData &= New String(Loc:dwFileSize)
        Loc:bRead  = TXM::ReadFile(Loc:hFile,ADDRESS(Loc:SData),Loc:dwFileSize,Loc:dwBytesRead,0)
     end
     TXM::CloseHandle(Loc:hFile)
  end
  Return Loc:SData

!    
TXM::WriteStrToFile   Procedure(String sFileName,String sData)
xFileName       CString(File:MaxFileName)
RetValue        Byte(False)
hFile           Long,Auto
RC              Long,Auto
dwBytesWritten  Long
  Code
  If Clip(Left(sFileName)) = '' then TXM::Mess('     !','WriteStrToFile')
  else
     xFileName = LongPath(Clip(sFileName))
     hFile     = TXM::CreateFile(xFileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0)  !    ,      ReadOnly !

     If hFile = INVALID_HANDLE_VALUE then TXM::Mess('    : ' & TXM::GetLastError(),'WriteStrToFile')
     else
        RC = TXM::WriteFile(hFile, sData, Size(sData), dwBytesWritten, 0)
        TXM::CloseHandle(hFile)

        If RC then RetValue = True
        else
           TXM::Mess('  : ' & TXM::GetLastError(),'WriteStrToFile')
        end
     end
  end

  Return RetValue

!    
TXM::ReplaceText      Procedure  (*String Stroka_,String Template_,String Field_,Long xFindTimes_ = 0)
Loc:LastIndex  Long(1)
Loc:FindIndex  Long,Auto
Loc:FindTimes  Long(0)
  Code
  Loop  
    Loc:FindIndex = InString(Clip(Upper(Template_)),Clip(Upper(Stroka_)),1,Loc:LastIndex)
    If Loc:FindIndex and ((Loc:FindIndex + Len(Clip(Template_))) < Size(Stroka_))
       Stroka_        = Stroka_[1:(Loc:FindIndex - 1)] & Clip(Field_) & Stroka_[(Loc:FindIndex + Len(Clip(Template_))):(Size(Stroka_))]
       Loc:LastIndex  = Loc:FindIndex + Len(Clip(Field_))

       Loc:FindTimes += 1
       If Loc:FindTimes = xFindTimes_ then Break.
    else
       Break
    end
  end

!    ANSI -> UTF8
TXM::ANSItoUTF8       Procedure  (String pStr)  !,String
UnicodeText   String(Size(pStr)*2+2)
UtfText       String(Size(pStr)*2+2)
Len           Long, Auto
bytesWritten  Long, Auto
  Code
  If    Clip(pStr) = ''     then Return ''
  elsIf Numeric(Clip(pStr)) then Return Clip(pStr)
  else
     bytesWritten = TXM::MultiByteToWideChar(TXM::GetACP(),0,Address(pStr),       Len(pStr),   Address(UnicodeText),Size(UnicodeText))
     Len =          TXM::WideCharToMultiByte(65001,        0,Address(UnicodeText),bytesWritten,Address(UTFText),    Size(UTFText),0,0)
     Return UtfText[1 : Len]
  end

!    UTF8 -> ANSI
TXM::UTF8toANSI       Procedure  (String pStr)  !,String
UnicodeText   String(Size(pStr)*2+2)
ANSIText      String(Size(pStr)*2+2)
bytesWritten  Long, Auto
Len           Long, Auto
  Code
  If (Size(pStr) = 0) Or (pStr = '<0>') then Return ''
  else
     bytesWritten = TXM::MultiByteToWideChar(65001,        0,Address(pStr),       Len(pStr),   Address(UnicodeText),Size(UnicodeText))
     Len          = TXM::WideCharToMultiByte(TXM::GetACP(),0,Address(UnicodeText),bytesWritten,Address(ANSIText),   Size(ANSIText),0,0)

     If Len <= 0 then Return ''
     else
        Loop
          If Sub(ANSIText,Len,1) = '<0>' then Len -= 1 else Break.
        end
        Return Sub(ANSIText,1,Len)
     end
  end

!  GUID-36
TXM::GetGUID          Procedure !,String
pGuid       String(16)
buf         String(128)
buf2        String(64)
cbSize      Long
xRetValue   String(36)
  Code
  If ~TXM::CoCreateGuid(pGUID)
     If TXM::StringFromGuid2(pGuid, buf, SIZE(buf) / 2)
        cbSize = TXM::WideCharToMultiByte(, , Address(buf), -1, Address(buf2), SIZE(buf2), 0, 0)
        If cbSize > 0 then xRetValue = buf2[2 : 37].
     end
  end

  Return xRetValue

! 
TXM::Mess             Procedure(String sText,String sScene)
  Code
  Message(Clip(sText),sScene,Icon:Exclamation,'&1. ')

!      
TXM::ReLoadQueue      Procedure(*Queue qSource, *Group gSource, *Queue qTarget)  !,Long,Proc
xCount  Long,Auto
  Code
  Free(qTarget)
  Loop xCount = 1 to Records(qSource)
    Get(qSource,xCount)

    Clear(qTarget)
    qTarget = gSource
    Add(qTarget)
  end
  Free(qSource)

  Return Records(qTarget)

!    XML 
TXM::Escape Procedure(String xStr) !, String
SIndex      Long,Auto
DIndex      Long(1)
ReplacedBy  CString(7),Auto
LenReplace  BYTE,Auto
xResult     String((Size(xStr) * 6) + 20)
  Code
  If Clip(xStr) = '' Or Numeric(xStr) then Return Clip(Left(xStr))
  else
     xResult = ''
     Loop SIndex = 1 to Len(Clip(xStr))

       Case Val(xStr[SIndex])
       Of Val('&')
          ReplacedBy = '&amp;'
          LenReplace = 5
       Of Val('>')
          ReplacedBy = '&gt;'
          LenReplace = 4
       Of Val('<')
          ReplacedBy = '&lt;'
          LenReplace = 4
       Of Val('''')
          ReplacedBy = '&apos;'
          LenReplace = 6
       Of Val('"')
          ReplacedBy = '&quot;'
          LenReplace = 6
       Of 1 To 9 OrOf 11 To 12 OrOf 14 To 31  !  ,  10,13
          ReplacedBy = ' '
          LenReplace = 1
       else
          ReplacedBy = xStr[SIndex]
          LenReplace = 1
       end

       xResult[(DIndex):(DIndex + LenReplace - 1)] = ReplacedBy
       DIndex += LenReplace

       If (DIndex + 10) > Size(xResult) then Break.  !  ()      
     end

     Return Clip(xResult)
  end
