!  ToyXML    Clarion CpXML
!   07.04.2023 .
! ------------------------------------------------
!    https://forum.clarionlife.net/
!  ,     Yufil ( )

  Include('CPXML.inc'), Once
  Include('svapi.inc'), Once
  Include('DynStr.inc'),Once  !  

  Map
    Module('tXML')            !  
      TXM::GetGUID(),String                                                     !  GUID
      TXM::LoadStrFromFile(String pFileName,Long xMaxByte = 0),*String          !    
      TXM::WriteStrToFile(String sFileName,String sData),Byte,Proc              !    
      TXM::ReLoadQueue(*Queue qSource,*Group gSource,*Queue qTarget),Long,Proc  !      
      TXM::PodpisEdo(*EDO::G_Podpisant Podpisant,Byte bInitial = False),String  !        
      TXM::Escape(String xStr),String                                           !    XML 
    end
  end

TXM::LenTagLone Equate( 256)            !      /  ( 100 Clarion     + UTF8)
TXM::LenTagFull Equate(2049)            !         /  (   + )

TXM::Q_Files Queue,Type                 !   
ID             CString(37)              ! ID 
Content        Any                      ! 
             end

TXM::G_Child Group,Type                 !    
Tag            CString(101)             !     
IdRecTag       CString(101)             !     
IdRecVal       CString(256)             !   
ChildQue       &Queue                   !     (  IdRecVal   IdRecTag)
             end

TXM::Q_Rules Queue,Type                 !       
FieldName      CString(101)             !  
IsFile         Byte(False)              !   -   BLOB  
Ignore         Byte(False)              !    
Child          Group(TXM::G_Child).     !    
             end

TXM::Q_Names Queue,Type                 !     
ChildTag       CString(101)             !      (    )
FullName       CString(TXM::LenTagFull) !   
Number         Long                     !  
Specified      Byte(False)              !     XML 
             end

! ---  XML

ToyXML       Class, Type, Module('tXML.clw'), Link('tXML.clw')

XmlDoc         &Document,    Private    !  XML
XmlCount       Long,         Private    !     
AllRecord      Long,         Private    !    

BasicGroup     &Group,       Private    !   
Progress       UShort,       Private    ! 
CurPercent     Long,         Private    !    

qDomList       &DOMQueue                !  DOM  
qFiles         &TXM::Q_Files,Private    !   
qRules         &TXM::Q_Rules,Private    !       
qNames         &TXM::Q_Names,Private    !     
qGroup         &TXM::Q_Names,Private    !    

FlagInit       Byte(False)              !  DOM 
DebugMode      Byte(False)              !  
FlagChild      Byte(False),Private      !    
TagSeparator   CString(2)               !     (  ,     InString)

Construct      Procedure
Destruct       Procedure
Init           Procedure(byte xVid_,*? xStr_,UShort xProgress_ = 0),Byte,Proc
Kill           Procedure
                                                       !    XML ()
PrepareXML     Procedure(*Group gGroup,String sRootTag),Byte,Proc
                                                       !       ()
ToGroup        Procedure(*Group gGroup,String sRootTag),Byte,Proc
                                                       !       ()
ToQueue        Procedure(*Queue qList, String sRootTag),Long,Proc

                                                       !    Xml   
GetXmlValue    Procedure(*Group gGroup,String sRootTag,String sNameTag),Byte,Proc
                                                       !      
GetAttValue    Procedure(*Group gGroup,String sNameTag,String sListTag),Byte,Proc
                                                       !       
GetTagValue    Procedure(*Group gGroup,String sFullTag,String sNameTag),Byte,Proc
                                                       !   ID     
WriteIdRecord  Procedure(String sNameTag, String sValueTag)
                                                       !      
GetChildList   Procedure(*TXM::G_Child gChild,String sNameTag)
                                                       !          
AddChildList   Procedure(*TXM::G_Child gChild,String sNameTag),Private

FreeRules      Procedure()                             !       / 
                                                       !     / 
SetRule        Procedure(String sFieldName,String sRuleName,? fRuleValue,<*Queue qChildList>)
                                                       !      / 
GetRule        Procedure(String sFieldName,String sRuleName,<*TXM::G_Child gChild>),String,Proc

                                                       !        ( Ignore  )
GroupToNames   Procedure(String sListTag,*Group gGroup),Private
                                                       !      
GroupDeadLoop  Procedure(String sListTag,*Group gGroup,String sPath,Long lColumn),Long,Proc,Private
                                                       !           / 
WhereByName    Procedure(String sListTag,String sFullName,Byte FixSpecified = False),Long
SpecifiedTag   Procedure(*? hzLabel),Byte              !     XML 
ValueByName    Procedure(String sFullName),?           !          
                                                       !          
ValueByGroup   Procedure(*Group gGroup,String sField),?

GetParentTag   Procedure(),String                      !         qDomList
GetFullTag     Procedure(),String                      !        qDomList
GetParentField Procedure(*Group gGroup,Long lColumn),String  !       
GetFullField   Procedure(*Group gGroup,Long lColumn),String  !        (AntiWhere)

FreeFiles      Procedure(),Private                     !    qFiles
ContentToBlob  Procedure(String sID_,Blob xBlob_)      !     qFiles  ID    Blob 
                                                       !     qFiles  ID    
ContentToFile  Procedure(String sID_,String sFileName),Byte,Proc

ClearIndicator Procedure(UShort xProgress_ = 0)        !  /    
ShowIndicator  Procedure                               !   

GetShortTag    Procedure(String sTag),String           !       
             end

  ! ---     (  19  2018 . N -7-15/820@)

EDO::G_FIOTip       Group,Name(''),Type                                ! 5.49 , ,    ()
Fam                   cString(  61),              Name('')            ! 
Name                  cString(  61),              Name('')                ! 
Otch                  cString(  61),              Name('')           ! 
                    end

EDO::G_OsnovaTip    Group,Name(''),Type                          ! 5.48   (, ) ()
Name                  cString( 256),              Name('')            !   -  (   " -")
NumOsn                cString( 256),              Name('')             !   - 
DateOsn               cString(  11),              Name('')            !    -  (   ..).
DopSvOsn              cString(1001),              Name('')           !  
IdDocOsn              cString( 256),              Name('')           !   - 
                    end

EDO::G_TextInfTip   Group,Name(''),Type                           ! 5.47   ()
Id                    cString(  51),              Name('')            ! 
Value                 cString(2001),              Name('')             ! 
                    end

EDO::G_SumNDSTip    Group,Name(''),Type                             ! 5.46   ()
Value                 Real,                       Name('')             !  N(19.2)
StrNoNDS              cString(  19),              Name('')             !  .   :  
DashChar              cString(   2),              Name('')             !  
                    end

EDO::G_SumAkzizTip  Group,Name(''),Type                           ! 5.45   ()
Summa                 Real,                       Name('')           !   N(19.2)
StrNoAkziz            cString(  11),              Name('')           !  .  :  
                    end

EDO::G_SvFLTip      Group,Name(''),Type                               ! 5.44     ()
RegDoc                cString( 101),              Name('')     !       ,
                                                                             !       -
InnFL                 cString(  13),              Name('')              !   .   ()
OtherInfo             cString( 256),              Name('')           !  ,   
FIO                   Group(EDO::G_FIOTip),       Name('').               ! , ,    (5.49)
                    end

EDO::G_SvIPTip      Group,Name(''),Type                               ! 5.43     ()
InnFL                 cString(  13),              Name('')              !   .   ()
DefINNFL              cString(   2),              Name('')           !   "-" ().     .
DocSv                 cString( 101),              Name('')         !    
OtherInfo             cString( 256),              Name('')           !  
FIO                   Group(EDO::G_FIOTip),Name('').                      ! , ,    (5.49)
                    end

EDO::G_ContactTip   Group,Name(''),Type                            ! 5.42   ()
Phone                 cString( 256),              Name('')                !   /
EMail                 cString( 256),              Name('')            !   
                    end

EDO::G_AdrInfTip    Group,Name(''),Type                             ! 5.41   ,           ()
OKSM                  cString(   4),              Name('')             !  .         
Address               cString(1001),              Name('')           ! 
                    end

EDO::G_AdrRFTip     Group,Name(''),Type                              ! 5.40     ()
Index                 cString(   7),              Name('')             ! 
Region                cString(   3),              Name('')          !  .   <>
District              cString(  51),              Name('')              ! 
City                  cString(  51),              Name('')              ! 
Locality              cString(  51),              Name('')         !  
Street                cString(  51),              Name('')              ! 
House                 cString(  21),              Name('')                ! 
Housing               cString(  21),              Name('')             ! 
Flat                  cString(  21),              Name('')              ! 
                    end

EDO::G_AddressTip   Group,Name(''),Type                              ! 5.39   
AdrRF                 Group(EDO::G_AdrRFTip),     Name('').             ! ,       (5.40)
AdrInf                Group(EDO::G_AdrInfTip),    Name('').            ! ,   ,           (5.41)
CodGAR                cString(  37),              Name('')             !         
                    end

EDO::G_SvBank       Group,Name(''),Type                                ! 5.38    ()
Name                  cString(1001),              Name('')           !  
BIK                   cString(  10),              Name('')                !    ()    "  "
CorrAccount           cString(  21),              Name('')            !   
                    end

EDO::G_BankRekv     Group,Name(''),Type                              ! 5.37   ()
PaymAccount           cString(  21),              Name('')         !   
SvBank                Group(EDO::G_SvBank),       Name('').            !    (5.38)
                    end

EDO::G_SvInNeUch    Group,Name(''),Type                              ! 5.36    ,           ()
Name                  cString(1001),              Name('')            !  
IdUL                  cString( 256),              Name('')            !   .    .
OtherInfo             cString( 256),              Name('')           !  ,   .  ,       .
                    end

EDO::G_SvULUch      Group,Name(''),Type                                ! 5.35    ,       ()
Name                  cString(1001),              Name('')            !  
InnUL                 cString(  11),              Name('')              ! .   <>.    
DefINNUL              cString(   2),              Name('')           !   "-" ().     .
KPP                   cString(  10),              Name('')                ! .   <>.
                    end

EDO::G_IdSv         Group,Name(''),Type                                  ! 5.34   ()
SvIP                  Group(EDO::G_SvIPTip),      Name('').              !     (5.43)
SvUL                  Group(EDO::G_SvULUch),      Name('').            !    ,       (5.35)
SvInNeUch             Group(EDO::G_SvInNeUch),    Name('').          !    ,           (5.36)
SvFL                  Group(EDO::G_SvFLTip),      Name('').      !    .   <>. (5.44)
                    end

EDO::G_UchasTip     Group,Name(''),Type                           ! 5.33       ()
OKPO                  cString(  11),              Name('')               !       
SubDivision           cString(1001),              Name('')         !  
InfoUchastn           cString( 256),              Name('')        !    
ShortName             cString( 256),              Name('')          !  
IdSv                  Group(EDO::G_IdSv),         Name('').              !   (5.34)
Address               Group(EDO::G_AddressTip),   Name('').             !  (5.39)
Contact               Group(EDO::G_ContactTip),   Name('').           !   (5.42)
BankRekv              Group(EDO::G_BankRekv),     Name('').          !   (5.37)
                    end

EDO::G_RepresentUL  Group,Name(''),Type                                    ! 5.32    () Name ???
SvGosReg              cString( 101),              Name('')     !      ,   
InnUL                 cString(  11),              Name('')              !   .   <>.
Name                  cString(1001),              Name('')            ! 
Position              cString( 129),              Name('')              ! 
OtherInfo             cString( 256),              Name('')           !  ,   
FIO                   Group(EDO::G_FIOTip),       Name('').               ! , ,    (5.49)
                    end

EDO::G_Podpisant    Group,Name(''),Type                             ! 5.31   ,    - ( )
ScopeAuth             cString(   3),              Name('')            !  
Status                cString(   3),              Name('')             ! 
BasisAuth             cString( 256),              Name('')            !   ()
BasisAuthEnt          cString( 256),              Name('')         !   () 
SvFL                  Group(EDO::G_SvFLTip),      Name('').                !  .   <> (5.44)
SvIP                  Group(EDO::G_SvIPTip),      Name('').                !    (5.43)
ReUL                  Group(EDO::G_RepresentUL),  Name('').                !    (5.32)
                    end

EDO::G_InfoField3   Group,Name('3'),Type                            ! 5.30      3
IdFileInfo            cString(  37),              Name('')       !     GUID.
TextInf               Group(EDO::G_TextInfTip),   Name('').          !   (5.47)
                    end

EDO::G_InfoTrV      Group,Name(''),Type                             ! 5.29    ,    
Date                  cString(  11),              Name('')         !   ,    .   <> ..
InfoTV                cString(1001),              Name('')           !   
                    end

EDO::G_TranNakl     Group,Name(''),Type                              ! 5.28  
Number                cString( 256),              Name('')        !   
Date                  cString(  11),              Name('')       !   .   <> ..
                    end

EDO::G_TranGruz     Group,Name(''),Type                              ! 5.27   
SvTransCargo          cString(1001),              Name('')         !     
TranNakl              Group(EDO::G_TranNakl),     Name('').          !  .       (5.28)
Carrier               Group(EDO::G_UchasTip),     Name('').        !  (5.33)
                    end

EDO::G_FLPer        Group,Name(''),Type                                 ! 5.26 ,     (  )
OtherInfo             cString( 256),              Name('')           !  ,   
Basis                 cString( 121),              Name('')         ! ,       
FIO                   Group(EDO::G_FIOTip),       Name('').               ! , ,  .   <> (5.49)
                    end

EDO::G_ReprEnt      Group,Name(''),Type                            ! 5.25  ,     (  )
Position              cString( 129),              Name('')          ! 
OtherInfo             cString( 256),              Name('')           !  ,   
Name                  cString( 129),              Name('')         !  
BasisT                cString( 121),              Name('')     ! ,       (  )
BasisR                cString( 121),              Name('')     !        (  )
FIO                   Group(EDO::G_FIOTip),       Name('').               ! , ,  .   <> (5.49)
                    end

EDO::G_OtherPerson  Group,Name(''),Type                                ! 5.24  
ReprEnt               Group(EDO::G_ReprEnt),      Name('').        !  ,     (  ) (5.25)
FLPer                 Group(EDO::G_FLPer),        Name('').             !  ,     (  ) (5.26)
                    end

EDO::G_WorkerSeller Group,Name(''),Type                            ! 5.23   
Position              cString( 129),              Name('')          ! 
OtherInfo             cString( 256),              Name('')           !  ,   
Basis                 cString( 121),              Name('')            !   ()
FIO                   Group(EDO::G_FIOTip),       Name('').               ! , ,  .   <> (5.49)
                    end

EDO::G_PersonTrans  Group,Name(''),Type                              ! 5.22   ,   ()
WorkerSeller          Group(EDO::G_WorkerSeller), Name('').        !    (5.23)
OtherPerson           Group(EDO::G_OtherPerson),  Name('').            !   (5.24)
                    end

EDO::G_SvPer        Group,Name(''),Type                                 ! 5.21    ()  ( ),  
Content               cString( 256),              Name('')            !  
VidOper               cString( 256),              Name('')            !  
DateShip              cString(  11),              Name('')            !    (  ).                          ...
DateStart             cString(  11),              Name('')            !      ( ,  ).     ...
DateEnd               cString(  11),              Name('')           !      ( ,  ).  ...
OsnPer                Group(EDO::G_OsnovaTip),    Name('').            !    (  ),    (5.48)
PersonTrans           Group(EDO::G_PersonTrans),  Name('').          !   ,   /  (5.22)
TranGruz              Group(EDO::G_TranGruz),     Name('').          !    (5.27)
InfoTrV               Group(EDO::G_InfoTrV),      Name('').         !    ,     (5.29)
                    end

EDO::G_SvProdPer    Group,Name(''),Type                             ! 5.20     3 -      ( )
SvPer                 Group(EDO::G_SvPer),        Name('').             !    ()  ( ),   (5.21)
InfoField3            Group(EDO::G_InfoField3),   Name('3').        !      (5.30)
                    end

EDO::G_TotalPaid    Group,Name(''),Type                              ! 5.19   "  "
CostNotTax            Real,                       Name('')   !   ,   (, ),     - 
CostAll               Real,                       Name('')    !   ,   (, ),     - 
DefCostAll            cString(   2),              Name('') !   ,   (, ).   "-" ().
SumNDS                Group(EDO::G_SumNDSTip),    Name('').       !   ,  ,  .   <>. (5.46)
KolvoAll              Real,                       Name('')         !  ( /) -   
                    end

EDO::G_NumIdGoods   Group,Name(''),Type                       ! 5.18    
IdTransPack           cString( 256),              Name('')     !    .      .
KIZ                   cString( 256),              Name('')                !   .      
NumberPack            cString( 256),              Name('')            !    ()/ (, ) 
                    end

EDO::G_TrackGoods   Group,Name(''),Type                           ! 5.17   ,  
RegNumTrack           cString(  30),              Name('')      !    .
UnitTrack             cString(   5),              Name('')       !    ,     
NameUnitTrack         cString( 256),              Name('')   !     ,     
KolvoTrack            Real,                       Name('')      !       
AddTrack              cString( 256),              Name('')         !     ,  
                    end

EDO::G_AddInfoGoods Group,Name(''),Type                            ! 5.16      /  ,  
SignGoods             cString(   2),              Name('')           ! :  /  /  /  / 
AddInfoSign           cString(   5),              Name('')           !    
UnitName              cString( 256),              Name('')          !   
CountryName           cString( 256),              Name('')        !     .    .
Kolvo                 Real,                       Name('')            !   (  )
ParamGoods            cString(1001),              Name('')        !  /   (    1 -)
GradeGoods            cString(  11),              Name('')            !  
ArticleGoods          cString(  51),              Name('')         !   (    1 -)
CodTov                cString( 101),              Name('')             !       (    1 -)
CodCat                cString(  28),              Name('')             !  .          
CodVidTov             cString(  11),              Name('')          !   .     .
TrackGoods            Group(EDO::G_TrackGoods),   Name('').       !   ,   (5.17)
NumIdGoods            Group(EDO::G_NumIdGoods),   Name('').   !    .     (5.18)
                    end

EDO::G_SvTD         Group,Name(''),Type                                  ! 5.15    
CodeCountry           cString(   4),              Name('')          !      ( 10 -)
DefCountry            cString(   2),              Name('')       !     .   "-"
RegNumTD              cString(  30),              Name('')            !     (   )
                    end

EDO::G_SvedTov      Group,Name(''),Type                               ! 5.14     /   ,  
NumRow                Long,                       Name('')             !   
Name                  cString(1001),              Name('')            !   (  ,  ),  
OKEI                  cString(   5),              Name('_')           !   .   <>.
DefOKEI               cString(   2),              Name('_')        !   .   "-" / .
Kolvo                 Real,                       Name('')             !  () ( 3 -)
Price                 Real,                       Name('')            !  ()    ( 4 -).
CostNoTax             Real,                       Name('')        !   (, ),     - 
TaxRate               cString(  36),              Name('')              !  .  : 0% | 10% | 18% | 20% | 10/110 | 18/118 | 20/120 |  
Cost                  Real,                       Name('')         !   (, ),     - 
DefCost               cString(   2),              Name('')      !   (, ),     - .
Akziz                 Group(EDO::G_SumAkzizTip),  Name('').             !      ( 6 -) <>. (5.45)
SumNDS                Group(EDO::G_SumNDSTip),    Name('').            !  ,   ( 8 -) <>. (5.46)
SvTD                  Group(EDO::G_SvTD),         Name('').              !     (5.15)
AddInfoGoods          Group(EDO::G_AddInfoGoods), Name('').        !      (5.16)
!TextInf               Group(EDO::G_TextInfTip),   Name('2').        ! *     2 <>. (5.47)
                    end

EDO::G_TableSF      Group,Name(''),Type                            ! 5.13   - (    2)
SvedTov               Group(EDO::G_SvedTov),      Name('').           ! *   ,   ,   (5.14)
TotalPaid             Group(EDO::G_TotalPaid),    Name('').          !   "  " (5.19)
                    end

EDO::G_InfoField1   Group,Name('1'),Type                            ! 5.12      1
IdFile                cString(  37),              Name('')       !    . GUID.
TextInf               Group(EDO::G_TextInfTip),   Name('').          !   <>. (5.47)
                    end

EDO::G_DocPodtvOtgr Group,Name(''),Type                          ! 5.11  ,    (, ,  )
NameDocShip           cString( 256),              Name('')        !    
NumberDocShip         cString( 256),              Name('')         !    
DateDocShip           cString(  11),              Name('')        !    .  ..
                    end

EDO::G_GovPurchase  Group,Name(''),Type                     ! 5.10          
DateContract          cString(  11),              Name('')        !   .  ..
NumberContract        cString( 101),              Name('')       !   
NumberAccount         cString(  12),              Name('')        !    
CodeBK                cString(  21),              Name('')   !     ()
CodeTarget            cString(  21),              Name('')        !   ()
CodeFK                cString(   5),              Name('')      !      
NameFK                cString(2001),              Name('')     !      
                    end

EDO::G_DopSvFHZ1    Group,Name('1'),Type                             ! 5.9       
IdGosCon              cString(  26),              Name('')           !   ,  ()
NameOKV               cString( 101),              Name('')            ! : 
CursVal               Real,                       Name('')            !  
Situation             cString(   2),              Name('')        !   -,     
GovPurchase           Group(EDO::G_GovPurchase),  Name(''). !           (5.10)
SvFactor              Group(EDO::G_UchasTip),     Name('').          !    (5.33)
OsnUstDenTreb         Group(EDO::G_OsnovaTip),    Name('').     !     (5.48)
                    end

EDO::G_SvPRD        Group,Name(''),Type                                 ! 5.8   -  ( 5 -)
NumberPRD             cString(  31),              Name('')           !  - 
DatePRD               cString(  11),              Name('')            !   - .  ...
SummaPRD              Real,                       Name('')           ! .       
                    end

EDO::G_GruzOt       Group,Name(''),Type                                ! 5.7    ( 3 -)
GruzOtpr              Group(EDO::G_UchasTip),     Name('').          !     (5.33)
HeIs                  cString(   5),              Name('')               !  " "
                    end

EDO::G_CorrectSF    Group,Name(''),Type                               ! 5.6  ( 1 -)
NumCorr               Long,                       Name('')         ! : N.  >= 1.    
DefNumCorr            cString(   2),              Name('')      ! : N
DateCorr              cString(  10),              Name('')        ! : .  ...
DefDateCorr           cString(   2),              Name('')     ! : 
                    end

EDO::G_SvSchFact    Group,Name(''),Type                              ! 5.5   - (    1)
NumberSF              cString(1001),              Name('')           !   - ( 1 -).  =  : / ( )
DateSF                cString(  11),              Name('')            !   () - ( 1 -).  ..
CodeOKV               cString(   4),              Name('')             ! :  ( 7 -).   <>.
CorrectSF             Group(EDO::G_CorrectSF),    Name('').           !  ( 1  - )                          (5.6)
SvProd                Group(EDO::G_UchasTip),     Name('').            !    ( 2, 2, 2 -)             (5.33)
GruzOt                Group(EDO::G_GruzOt),       Name('').            !    ( 3 -)             (5.7)
GruzPol               Group(EDO::G_UchasTip),     Name('').         !     ( 4 -)             (5.33)
SvPRD                 Group(EDO::G_SvPRD),        Name('').             !   -  ( 5 -) (5.8)
SvPokup               Group(EDO::G_UchasTip),     Name('').           !    ( 6, 6, 6 -)           (5.33)
DopSvFHZ1             Group(EDO::G_DopSvFHZ1),    Name('1').         !         (5.9)
DocPodtvOtgr          Group(EDO::G_DocPodtvOtgr), Name('').      !  ,    /     (5.11)
InfoField1            Group(EDO::G_InfoField1),   Name('1').        !      1                  (5.12)
                    end

EDO::G_Document     Group,Name(''),Type                              ! 5.4 -,     ,    .
KND                   cString(   8),              Name('')                !    .   <>.  : 1115131
Func                  cString(   7),              Name('')            ! .  -  ,  -    .  ,  - .  .
PoFactHZ              cString( 256),              Name('')           !        =  .
NameDocOtp            cString( 256),              Name('')         !   ,   (  )
DateInfPr             cString(  11),              Name('')          !      - ( ).   ..
TimeInfPr             cString(   9),              Name('')          !     - ( ).  ..
NameEcoSubject        cString(1001),              Name('')    !    -    - ( ).
OsnDover              cString( 121),              Name('')    ! ,         -.
SoglStrDop            cString(  15),              Name('')      !        .
SvSchFact             Group(EDO::G_SvSchFact),    Name('').          !   -          (    1) (5.5)
TableSF               Group(EDO::G_TableSF),      Name('').        !   -    (    2) (5.13)
SvProdPer             Group(EDO::G_SvProdPer),    Name('').         !      (    3) (5.20)
Podpisant             Group(EDO::G_Podpisant),    Name('').         ! *  ,     ( )       (5.31)
                    end

EDO::G_SvOEDOtpr    Group,Name(''),Type                             ! 5.3        - ( )
Name                  cString(1001),              Name('')            ! 
InnUL                 cString(  11),              Name('')              ! 
IdEDO                 cString(   4),              Name('')              !       -
                    end

EDO::G_SvUchDocObor Group,Name(''),Type                           ! 5.2     
IdOtp                 cString(  47),              Name('')             !    -    -
IdPol                 cString(  47),              Name('')              !    -    -
SvOEDOtpr             Group(EDO::G_SvOEDOtpr),    Name('').         !        - (5.3)
                    end

EDO::G_File         Group,Name(''),Type                                  ! 5.1  
IdFile                cString( 256),              Name('')             !  .  ()    ( ).
VersForm              cString(   6),              Name('')           !  .  : 5.01
VersProg              cString(  41),              Name('')           !  ,     .
SvUchDocObor          Group(EDO::G_SvUchDocObor), Name('').       !      (5.2)
Document              Group(EDO::G_Document),     Name('').          ! -,      /   (5.4)
                    end

! ---  XML

TXM::Q_Attr  Queue,Type                  !    
Name           CString(TXM::LenTagLone)  !       
Value          CString(1024)             !  
             end

TXM::G_IdSv  Group,Type                  !   
OwnerShip      Byte                      !   1 =  / 2 =  / 3 =  / 4 = 
Name           cString(1001)             ! 
Inn            cString(  13)             ! 
KPP            cString(  10)             ! 
DocSv          cString( 101)             !    
OtherInfo      cString( 256)             !  
             end

PushXML      Class, Type, Module('tXML.clw'), Link('tXML.clw')
XmlBuffer      &IDynStr,Private          !    XML
Encoding       Byte(False)               !   UTF-8
LineBreak      Byte(False)               !   
qAttr          &TXM::Q_Attr,Private      !    

Construct      Procedure
Destruct       Procedure
Init           Procedure(byte bEncoding = False,byte bLineBreak = False,UShort xProgress = 0),Byte,Proc
Kill           Procedure

SaveAs         Procedure(String sFileName),Byte,Proc      !  XML   
AddEndLine     Procedure,Private                          !   

AddCap         Procedure                                  !   
AddRem         Procedure(String sText)                    !  
AddStr         Procedure(String sText)                    !   

Closed         Procedure(String sTag,<String sValue>)     !   
Opened         Procedure(String sTag),Byte                !   
EndTag         Procedure(String sTag)                     !    

AddFile        Procedure(String sTag,String sFileName)    !      Base64
AddCData       Procedure(String sTag,String sValue)       !   CData

                                                          !   ()
WriteTag       Procedure(String sTag,<String sValue>,Byte bFlagClose = False),Private
                                                          !       ( ,  )
NewAtr         Procedure(String sName,String sValue,Byte bAddNotValue = True)
                                                          !      
SetAtr         Procedure(String sName,String sValue,Byte bAddNotValue = True)

! ---    

IdSv           Group(TXM::G_IdSv).                        !   
Bank           Group(EDO::G_BankRekv).                    !  

EdoIdSv        Procedure                                  !   5.34   ()
EdoBank        Procedure                                  !   5.37         ()
EdoAddress     Procedure(Byte bSRF, String sAddressText)  !   5.39                       ()
EdoContact     Procedure(String sPhone, String sEMail)    !   5.42            ()
EdoSplitFIO    Procedure(String sName)                    !   5.49 EDO::G_FIOTip              ()
             end
